#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <conio.h>
#include <tchar.h>
#include <windows.h>
#include <winnt.h>

#include <objbase.h>
#include <comdef.h>
#include <wbemidl.h>

#include <strsafe.h>

bool set_privilege( const char* privilege_name, const bool enable );
void print( char* format, ... );
void test( );

bool require_investing_privilege( bool& necessity );

bool require_wmi_proxy( bool& necessity );
HRESULT get_wmi_information( );
HRESULT get_wmi_memory( IWbemServices* wbem_services_interface );

#if !defined( QWORD )
//typedef unsigned long long QWORD;
#	define QWORD DWORDLONG
#endif

int main()
{
	// ϐƂ֐l̂ʓ|ɂȂĂ
	CoInitializeEx( NULL, COINIT_SPEED_OVER_MEMORY | COINIT_MULTITHREADED );
	test();
	CoUninitialize();
#ifndef _DEBUG
	print( "ʂsI܂BL[AE̕{^ƏI܂B" );
	_getch();
#endif
	return 0;
}

bool set_privilege( const char* privilege_name, const bool enable )
{
	bool return_value = false;
	HANDLE token_handle = NULL;
	TOKEN_PRIVILEGES new_token_privileges;

	memset( &new_token_privileges, 0, sizeof( TOKEN_PRIVILEGES ) );

	if( FALSE == OpenProcessToken( GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES, &token_handle ) ) {
		goto on_err;
	}

	if( FALSE == LookupPrivilegeValue( NULL, privilege_name, &new_token_privileges.Privileges[0].Luid ) ) {
		goto on_err;
	}

	new_token_privileges.PrivilegeCount = 1;

	if( false != enable ) {
		new_token_privileges.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
	} else {
		new_token_privileges.Privileges[0].Attributes = 0UL;	// disable
	}

	if( FALSE == AdjustTokenPrivileges( token_handle, FALSE, &new_token_privileges, sizeof( TOKEN_PRIVILEGES ), NULL, NULL ) ) {
		goto on_err;
	}

	return_value = true;
on_err:
	if( token_handle )
		CloseHandle( token_handle );
	return return_value;
}

void print( char* format, ... )
{
	va_list arguments;
	char* buffer = NULL;
	size_t buffer_length;
#if 1
	va_start( arguments, format );
	buffer_length = ( size_t )_vscprintf( format, arguments ) + 1;
	buffer = ( char* )malloc( buffer_length );
	vsprintf_s( buffer, buffer_length, format, arguments );
	puts( buffer );
	free( buffer );
	va_end( arguments );
#else
	// ܂G[͏oȂƎvǁEEE
	char* new_format = NULL;
	size_t format_length, new_format_lenght;

	StringCchLength( format, STRSAFE_MAX_CCH, &format_length );
	new_format_lenght = format_length + 2;
	new_format = ( char* )malloc( new_format_lenght );
	StringCchCopy( new_format, new_format_lenght, format );
	StringCchCat( new_format, new_format_lenght, "\n" ); //st

	va_start( arguments, format );
	buffer_length = ( size_t )_vscprintf( new_format, arguments ) + 1;
	buffer = ( char* )malloc( buffer_length );
	vsprintf_s( buffer, buffer_length, new_format, arguments );
	puts( buffer );
	free( buffer );
	va_end( arguments );

	free( new_format );
#endif
}

bool require_investing_privilege( bool& necessity )
{
	SID_IDENTIFIER_AUTHORITY authority = SECURITY_NT_AUTHORITY;
	HANDLE token_handle;
	PSID psid;
	const size_t buffer_length = 2048;
	BYTE buffer[ buffer_length ];
	DWORD returned_length;
	bool return_value = false;

	// Ƃ肠KvĎɂĂBnecessity̒l͐MpłȂB
	necessity = true;

	if( FALSE == OpenProcessToken( GetCurrentProcess(), TOKEN_QUERY, &token_handle ) ) {
		goto on_err;
	}
	if( FALSE == GetTokenInformation( token_handle, TokenGroups, buffer, buffer_length, &returned_length ) ) {
		goto on_err;
	}

	// Administrators O[vɏĂ邩ׂ
	DWORD alias = 0;
	BYTE number_of_sub_authorities = 2;
	if( FALSE != AllocateAndInitializeSid( &authority, number_of_sub_authorities, SECURITY_BUILTIN_DOMAIN_RID, DOMAIN_ALIAS_RID_ADMINS, 0, 0, 0, 0, 0, 0, &psid ) ) {
		for( ULONG count = 0; count < ( ( PTOKEN_GROUPS )buffer )->GroupCount; ++count ) {
			if( EqualSid( psid, ( ( PTOKEN_GROUPS)buffer )->Groups[ count ].Sid ) ) {
				// administrators ł
				print( "  ݃OCĂ郆[ÚAǗ҃O[v̂悤ł");
				print( "  Iȓt^͕Kv܂" );
				necessity = false;
			}
		}
		FreeSid( psid );
	}
	if( necessity ) {
		print( "  ݃OCĂ郆[ÚAǗ҃O[vł͂Ȃ悤ł" );
		print( "  Iȓt^Kv܂" );
	}

	// Ƃ肠AŌ܂łBnecessity̒l͂ȂɐMpłB
	return_value = true;
on_err:
	if( token_handle )
		CloseHandle( token_handle );
	return return_value;
}

bool confirm_os_version( DWORD os_major_version, DWORD os_minor_version, DWORD os_platform_id, WORD os_sp_major_version, WORD os_sp_minor_version )
{
	OSVERSIONINFOEX os_version_info;
	DWORD type_mask = 0;
	QWORD condition_mask = 0;
	BOOL result;

	memset( &os_version_info, 0, sizeof( OSVERSIONINFOEX ) );
	type_mask = VER_PLATFORMID | VER_MAJORVERSION | VER_MINORVERSION | VER_SERVICEPACKMAJOR | VER_SERVICEPACKMINOR;

	os_version_info.dwOSVersionInfoSize = sizeof( OSVERSIONINFOEX );
	os_version_info.dwMajorVersion = os_major_version;
	os_version_info.dwMinorVersion = os_minor_version;
	os_version_info.dwPlatformId = os_platform_id;
	os_version_info.wServicePackMajor = os_sp_major_version;
	os_version_info.wServicePackMinor = os_sp_minor_version;

	VER_SET_CONDITION( condition_mask, VER_PLATFORMID, VER_GREATER_EQUAL );
	VER_SET_CONDITION( condition_mask, VER_MAJORVERSION, VER_EQUAL );
	VER_SET_CONDITION( condition_mask, VER_MINORVERSION, VER_EQUAL );
	VER_SET_CONDITION( condition_mask, VER_SERVICEPACKMAJOR, VER_GREATER_EQUAL );
	VER_SET_CONDITION( condition_mask, VER_SERVICEPACKMINOR, VER_GREATER_EQUAL );

	result = VerifyVersionInfo( &os_version_info, type_mask, condition_mask );
	return FALSE != result ? true : false;
}

void test()
{
	bool require_explicit_privilege;
	
	if( !require_investing_privilege( require_explicit_privilege ) ) {
		print( "  t^Kvǂ擾ł܂ł" );
		print( "  Ƃ肠t^āAs݂܂" );
		require_explicit_privilege = true;
		//goto on_err;
	}
	
	OSVERSIONINFOEX os_version_info;
	memset( &os_version_info, 0, sizeof( OSVERSIONINFOEX ) );
	os_version_info.dwOSVersionInfoSize = sizeof( OSVERSIONINFOEX );
	GetVersionEx( ( OSVERSIONINFO *)&os_version_info );

	if( require_explicit_privilege ) {
		if( 5 == os_version_info.dwMajorVersion) {
			switch ( os_version_info.dwMinorVersion ) {
				case 0:
					if( !confirm_os_version( 5, 0, VER_PLATFORM_WIN32_NT, 4, 0 ) ) {
						print( "  Windows 2000 Ŏsɂ́AT[rXpbNSȏオKvł" );
						goto on_err;
					}
					break;
				case 1:
					if( !confirm_os_version( 5, 1, VER_PLATFORM_WIN32_NT, 2, 0 ) ) {
						print( "  Windows XP Ŏsɂ́AT[rXpbNQȏオKvł" );
						goto on_err;
					}
					break;
				case 2:
					// 2003 ͑v
					break;
				default:
					print( "  ͂̂ȂƂɗĂ܂" );
					print( "  s𒆎~܂" );
					goto on_err;
			}
		} /* vista(=6) ȍ~Ȃv */

		// administrators O[vȊÕ[U͓t^ȂƂ߂H
		// SE_IMPERSONATE_NAME ꂽ̂́A2000 SP4AXP SP2A2003ȍ~̂݁B
		if( false == set_privilege( SE_IMPERSONATE_NAME, true ) ) {
			goto on_err;
		}
		if( false == set_privilege( SE_SECURITY_NAME, true ) ) {
			goto on_err;
		}
	}

	get_wmi_information();

on_err:
	;
}

bool require_wmi_proxy( bool& necessity )
{
	OSVERSIONINFOEX os_version_info;
	DWORD type_mask = 0;
	QWORD condition_mask = 0;
	bool return_value = false;

	memset( &os_version_info, 0, sizeof( OSVERSIONINFOEX ) );
	os_version_info.dwOSVersionInfoSize = sizeof( OSVERSIONINFOEX );
	os_version_info.dwPlatformId = VER_PLATFORM_WIN32_NT;
	os_version_info.dwMajorVersion = 5;
	os_version_info.dwMinorVersion = 1;

	type_mask = VER_PLATFORMID | VER_MAJORVERSION | VER_MINORVERSION;
	VER_SET_CONDITION( condition_mask, VER_PLATFORMID, VER_GREATER_EQUAL );
	VER_SET_CONDITION( condition_mask, VER_MAJORVERSION, VER_GREATER_EQUAL );
	VER_SET_CONDITION( condition_mask, VER_MINORVERSION, VER_GREATER_EQUAL );

	BOOL result = VerifyVersionInfo( &os_version_info, type_mask, condition_mask );
	//DWORD reason = GetLastError();

	if( FALSE != result ) {
		necessity = true;
		return_value = true;
	}
	return return_value;
}

HRESULT get_wmi_information()
{
	HRESULT hr;
	IWbemLocator *wbem_locator_interface = NULL;
	IWbemServices *wbem_services_interface = NULL;

	hr = CoCreateInstance(
		CLSID_WbemAdministrativeLocator,
		NULL,
		CLSCTX_INPROC_SERVER,
		IID_IWbemLocator,
		( LPVOID * )&wbem_locator_interface );
	DWORD reason = GetLastError();
	if( FAILED( hr ) ) {
		//print( "  WMI P[^̍쐬Ɏs܂BG[R[hF%08X", hr );
		print( "  WMI P[^̍쐬Ɏs܂BȉR" );
		switch( hr ) {
			case REGDB_E_CLASSNOTREG:
				print( "  Return Value reason: REGDB_E_CLASSNOTREG" );
				print( "    REGDB_E_CLASSNOT_REG: A specified class is not registered in the registration database. Also can indicate that the type of server you requested in the CLSCTX enumeration is not registered or the values for the server types in the registry are corrupt." );
				break;
			case CLASS_E_NOAGGREGATION:
				print( "  Return Value reason: CLASS_E_NOAGGREGATION" );
				print( "    CLASS_E_NOAGGREGATION: This class cannot be created as part of an aggregate." );
				break;
			case E_NOINTERFACE:
				print( "  Return Value reason: E_NOINTERFACE" );
				print( "    E_NOINTERFACE: The specified class does not implement the requested interface, or the controlling IUnknown does not expose the requested interface." );
				break;
			default:
				print( "  Return Value reason: Unknown(code: %08x)", hr );
				print( "    not defined" );
		}
		LPVOID str_reason;
		FormatMessage( FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS, NULL, reason, MAKELANGID( LANG_NEUTRAL, SUBLANG_DEFAULT ), (LPSTR)&str_reason, 0, NULL );
		print( "  GetLastError reason: %s", str_reason );
		LocalFree( str_reason );
		return -1;
	}

	_bstr_t bstr_server_name( "\\\\.\\root\\cimv2" );
	hr = wbem_locator_interface->ConnectServer( static_cast< BSTR >( bstr_server_name ), NULL, NULL, NULL, 0, NULL, NULL, &wbem_services_interface );
	if( FAILED( hr ) ) {
		print( "  WMI T[rXւ̐ڑɎs܂BG[R[hF%08X", hr );
		wbem_locator_interface->Release();
		return -1;
	}

	bool result, require_proxy;
	result = require_wmi_proxy( require_proxy );
	if( result && require_proxy ) {
		// ZLeBݒccH
		hr = CoSetProxyBlanket( wbem_services_interface, RPC_C_AUTHN_WINNT, RPC_C_AUTHZ_NONE, NULL, RPC_C_AUTHN_LEVEL_CALL, RPC_C_IMP_LEVEL_IMPERSONATE, NULL, EOAC_NONE );
		if( FAILED( hr ) ) {
			print( "  WMIvLV̐ݒɎs܂B" );
			wbem_services_interface->Release();
			wbem_locator_interface->Release();
			return -1;
		}
	}

	get_wmi_memory( wbem_services_interface );

	if( wbem_services_interface )	wbem_services_interface->Release();
	if( wbem_locator_interface )	wbem_locator_interface->Release();

	return S_OK;
}

HRESULT get_wmi_memory( IWbemServices* wbem_services_interface )
{
	HRESULT hr;
	IEnumWbemClassObject *enum_wbem_class_object_interface = NULL;
	IWbemClassObject *wbem_class_object_interface = NULL;

	print( "@Win32_ComputerSystem 񋓎q𐶐܂" );

	_bstr_t bstr_service_filter_name( _T( "Win32_ComputerSystem" ) );
	hr = wbem_services_interface->CreateInstanceEnum( static_cast< BSTR >( bstr_service_filter_name ), WBEM_FLAG_FORWARD_ONLY | WBEM_FLAG_SHALLOW, NULL, &enum_wbem_class_object_interface );

	if( WBEM_S_NO_ERROR == hr ) {
		DWORD number_of_objects_read;

		enum_wbem_class_object_interface->Next( WBEM_INFINITE, 1, &wbem_class_object_interface, &number_of_objects_read );

		_bstr_t bstr_object_class_name( "TotalPhysicalmemory" );
		VARIANT value;
		CIMTYPE value_type;
		wbem_class_object_interface->Get( static_cast< BSTR >( bstr_object_class_name ), 0, &value, &value_type, NULL );

		VariantChangeType( &value, &value, 0, static_cast< VARTYPE >( value_type ) );

		print( "  eʁF%uKoCg", static_cast< DWORD >( V_UI4( &value ) / ( 1024 * 1024 ) ) );
		
		VariantClear( &value );
	}

	if( wbem_class_object_interface )		wbem_class_object_interface->Release();
	if( enum_wbem_class_object_interface )	enum_wbem_class_object_interface->Release();

	return S_OK;
}
